#include	<pic.h>

/*

Freely distributable in this original form.
Any questions or comments? See the email address at www.microchipC.com

Bit counter by Ratko Tomic, modified for PIC micro by Shane Tolmie
*/

unsigned char bit_count(unsigned int x)
{
	unsigned char n=0;
/*
** The loop will execute once for each bit of x set, this is in average
** twice as fast as the shift/test method.
*/
	if (x) do
			n++;
		while (0!=(x=x & (x-1)));
	return (n);
}

unsigned int n;
unsigned char c;

void main(void)
{

	n=0;
	while (n<0xFFFE)
	{
		n++;	//put a break point here and watch c and n!
		c=bit_count(n);
		
	}
}

